package org.jeecg.modules.stm.metric.controller;

import java.time.LocalDateTime;
import java.time.temporal.ChronoUnit;
import java.util.Arrays;
import java.util.Date;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.metric.service.IMetricAppSystemReportService;
import org.jeecg.modules.stm.metric.entity.MetricAppSystemReport;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 应用系统运行记录表
 * @Author: jeecg-boot
 * @Date:   2024-03-23
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/metric/metricAppSystemReport")
@Slf4j
public class MetricAppSystemReportController extends JeecgController<MetricAppSystemReport, IMetricAppSystemReportService> {
	@Autowired
	private IMetricAppSystemReportService metricAppSystemReportService;
	
	/**
	 * 分页列表查询
	 *
	 * @param metricAppSystemReport
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "应用系统运行记录表-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<MetricAppSystemReport>> queryPageList(MetricAppSystemReport metricAppSystemReport,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<MetricAppSystemReport> queryWrapper = QueryGenerator.initQueryWrapper(metricAppSystemReport, req.getParameterMap());
		Page<MetricAppSystemReport> page = new Page<MetricAppSystemReport>(pageNo, pageSize);
		IPage<MetricAppSystemReport> pageList = metricAppSystemReportService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param metricAppSystemReport
	 * @return
	 */
	@AutoLog(value = "应用系统运行记录表-添加")
	  
	@RequiresPermissions("metric:metric_app_system_report:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody MetricAppSystemReport metricAppSystemReport) {
		metricAppSystemReport.setFillTime(new Date());
		metricAppSystemReport.setTotalTimelen(computeTotalTime(metricAppSystemReport));
		metricAppSystemReportService.save(metricAppSystemReport);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param metricAppSystemReport
	 * @return
	 */
	@AutoLog(value = "应用系统运行记录表-编辑")
	  
	@RequiresPermissions("metric:metric_app_system_report:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody MetricAppSystemReport metricAppSystemReport) {
		metricAppSystemReport.setTotalTimelen(computeTotalTime(metricAppSystemReport));
		metricAppSystemReportService.updateById(metricAppSystemReport);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "应用系统运行记录表-通过id删除")
	  
	@RequiresPermissions("metric:metric_app_system_report:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		metricAppSystemReportService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "应用系统运行记录表-批量删除")
	  
	@RequiresPermissions("metric:metric_app_system_report:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.metricAppSystemReportService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "应用系统运行记录表-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<MetricAppSystemReport> queryById(@RequestParam(name="id",required=true) String id) {
		MetricAppSystemReport metricAppSystemReport = metricAppSystemReportService.getById(id);
		if(metricAppSystemReport==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(metricAppSystemReport);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param metricAppSystemReport
    */
    @RequiresPermissions("metric:metric_app_system_report:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, MetricAppSystemReport metricAppSystemReport) {
        return super.exportXls(request, metricAppSystemReport, MetricAppSystemReport.class, "应用系统运行记录表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("metric:metric_app_system_report:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, MetricAppSystemReport.class);
    }

	private int computeTotalTime(MetricAppSystemReport metricAppSystemReport) {
		int year = metricAppSystemReport.getFillYear();
		int quarter = metricAppSystemReport.getFillQuarter();
		LocalDateTime startDate = LocalDateTime.of(year, (quarter-1) * 3+1, 1,0,1);
		LocalDateTime endDate = LocalDateTime.of(year, (quarter-1) * 3+1, 1,23,59).plusMonths(3).minusDays(1);
		int minutesRemaining = (int)startDate.until(endDate, ChronoUnit.MINUTES);
		return minutesRemaining;

	}

}
